# $Revision: 1.42 $, $Date: 2011/09/28 13:59:19 $
#
# Conditional build:
%bcond_with	amr		# AMR-NB and AMR-WB (floating-point) support
%bcond_without	faad		# AAC decoding support
%bcond_without	ffmpeg		# ffmpeg support
%bcond_without	freetype	# freetype support
%bcond_without	jpeg		# JPEG support
%bcond_without	js		# JavaScript support
%bcond_without	mad		# MP3 support
%bcond_without	png		# PNG support
%bcond_without	xvid		# xvid support
%bcond_without	wx		# wxWidgets support
#
Summary:	GPAC - an implementation of the MPEG-4 Systems standard (ISO/IEC 14496-1)
Summary(pl.UTF-8):	GPAC - implementacja standardu MPEG-4 Systems (ISO/IEC 14496-1)
Name:		gpac
Version:	0.4.5
Release:	8
License:	LGPL v2+
Group:		Applications/Multimedia
Source0:	http://downloads.sourceforge.net/gpac/%{name}-%{version}.tar.gz
# Source0-md5:	755e8c438a48ebdb13525dd491f5b0d1
Patch0:		%{name}-install.patch
Patch1:		%{name}-libpng.patch
Patch2:		%{name}-pic.patch
Patch3:		%{name}-xulrunner.patch
Patch4:		%{name}-amr.patch
Patch5:		%{name}-ffmpeg.patch
Patch6:		%{name}-install-is-not-clean.patch
Patch7:		%{name}-flags.patch
Patch8:		%{name}-ffmpeg-0.8.patch
URL:		http://gpac.sourceforge.net/
BuildRequires:	SDL-devel
BuildRequires:	a52dec-libs-devel
BuildRequires:	alsa-lib-devel >= 0.9
%{?with_amr:BuildRequires:	amrnb-devel}
%{?with_amr:BuildRequires:	amrwb-devel}
%{?with_faad:BuildRequires:	faad2-devel}
%{?with_ffmpeg:BuildRequires:	ffmpeg-devel >= 0.6}
%{?with_freetype:BuildRequires:	freetype-devel}
BuildRequires:	jack-audio-connection-kit-devel
%{?with_js:BuildRequires:	js-devel}
%{?with_jpeg:BuildRequires:	libjpeg-devel}
%{?with_mad:BuildRequires:	libmad-devel}
BuildRequires:	libogg-devel
%{?with_png:BuildRequires:	libpng-devel}
BuildRequires:	libtheora-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libxml2-devel
BuildRequires:	openjpeg-devel
BuildRequires:	pulseaudio-devel
BuildRequires:	rpmbuild(macros) >= 1.357
BuildRequires:	sed >= 4.0
BuildRequires:	unzip
%{?with_wx:BuildRequires:	wxGTK2-devel >= 2.6.0}
%{?with_wx:BuildRequires:	wxGTK2-unicode-devel >= 2.6.0}
BuildRequires:	xmlrpc-c-server-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXv-devel
BuildRequires:	xulrunner-devel >= 1.9.1
%{?with_xvid:BuildRequires:	xvid-devel}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
GPAC is an implementation of the MPEG-4 Systems standard (ISO/IEC
14496-1) developed from scratch in ANSI C.

The main development goal is to provide a clean (a.k.a. readable by as
many people as possible), small and flexible alternative to the MPEG-4
Systems reference software (known as IM1 and distributed in ISO/IEC
14496-5). The MPEG-4 Reference software is indeed a very large piece
of software, designed to verify the standard rather than provide a
small, production-stable software. GPAC is written in ANSI C for
portability reasons (embedded platforms and DSPs) with a simple goal:
keep the memory footprint as low as possible. The project will at term
provide player(s), systems encoders and publishing tools for content
distribution.

%description -l pl.UTF-8
GPAC to implementacja standardu MPEG-4 Systems (ISO/IEC 14496-1)
stworzona od zera w ANSI C.

Głównym celem tworzenia jej jest dostarczenie czystej (tzn. czytelnej
dla jak największej liczby ludzi), małej i elastycznej alternatywy dla
wzorcowego oprogramowania MPEG-4 Systems (znanego jako IM1 i
rozprowadzanego w ISO/IEC 14496-5). Wzorcowe oprogramowanie MPEG-4
jest bardzo dużą porcją kodu, zaprojektowaną raczej do zweryfikowania
standardu niż dostarczenia małej, stabilnej wersji produkcyjnej. GPAC
jest pisany w ANSI C ze względu na przenośność (platformy wbudowane i
DSP) z prostym celem: wymagać tak mało pamięci, jak to tylko możliwe.
Projekt docelowo dostarczy odtwarzacz(e), kodery systemowe i narzędzia
do publikacji w celu dystrybucji materiałów.

%package devel
Summary:	Header files for GPAC library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki GPAC
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for GPAC library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki GPAC.

%package gui
Summary:	wxWidgets-based GUI for GPAC
Summary(pl.UTF-8):	Oparty na wxWidgets graficzny interfejs do GPAC
Group:		X11/Applications/Multimedia
Requires:	%{name} = %{version}-%{release}

%description gui
Osmo4 - wxWidgets-based GUI for GPAC.

%description gui -l pl.UTF-8
Osmo4 - oparty na wxWidgets graficzny interfejs do GPAC.

%package -n browser-plugin-%{name}
Summary:	GPAC browser plugin
Summary(pl.UTF-8):	Wtyczka GPAC do przegląderek WWW
Group:		X11/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	browser-plugins >= 2.0
Requires:	browser-plugins(%{_target_base_arch})

%description -n browser-plugin-%{name}
GPAC plugin for Netscape-compatible WWW browsers.

%description -n browser-plugin-%{name} -l pl.UTF-8
Wtyczka GPAC dla przeglądarek WWW zgodnych z Netscape.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%if %{with amr}
sed -i -e 's/amr_\([nw]b\)_ft/amr\1/' modules/amr_float_dec/amr_float_dec.c
%endif
sed -i -e 's/wx-config/wx-gtk2-unicode-config/' configure
chmod a+x configure

%build
cd applications/osmozilla
xpidl -m header -I /usr/share/idl/xulrunner nsIOsmozilla.idl
xpidl -m typelib -I /usr/share/idl/xulrunner nsIOsmozilla.idl
cp -f nsIOsmozilla.xpt nsIOsmozilla.xpt_linux
cd ../..
%configure \
	--X11-path=/usr \
	--cc="%{__cc}" \
	--disable-opt \
	%{!?with_wx:--disable-wx} \
	%{?with_amr:--enable-amr} \
	--enable-joystick \
	--enable-pic \
	--extra-cflags="%{rpmcflags}" \
	--extra-ldflags="%{rpmldflags}" \
	--mozdir=%{_browserpluginsdir} \
	%{!?with_faad:--use-faad=no} \
	%{!?with_ffmpeg:--use-ffmpeg=no} \
	%{!?with_freetype:--use-ft=no} \
	%{!?with_jpeg:--use-jpeg=no} \
	%{!?with_js:--use-js=no} \
	%{!?with_mad:--use-mad=no} \
	%{!?with_png:--use-png=no} \
	%{!?with_xvid:--use-xvid=no} \
	--xulsdk-path="/usr/include/xulrunner -I/usr/include/nspr"

%{__make} -j1 \
	BUILD_INSTALL=yes \
	CXX="%{__cxx} -fPIC" \
	libdir=%{_lib}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	libdir=%{_lib} \
	MOZILLA_DIR=$RPM_BUILD_ROOT%{_browserpluginsdir}

install -d $RPM_BUILD_ROOT%{_includedir}
cp -a include/gpac $RPM_BUILD_ROOT%{_includedir}/gpac

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post -n browser-plugin-%{name}
%update_browser_plugins

%postun -n browser-plugin-%{name}
if [ "$1" = 0 ]; then
	%update_browser_plugins
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS BUGS Changelog README TODO
%attr(755,root,root) %{_bindir}/MP4Box
%attr(755,root,root) %{_bindir}/MP4Client
%attr(755,root,root) %{_libdir}/libgpac-%{version}.so
%attr(755,root,root) %ghost %{_libdir}/libgpac.so
%dir %{_libdir}/gpac
%attr(755,root,root) %{_libdir}/gpac/gm_*.so
%{_datadir}/gpac
%{_mandir}/man1/gpac.1*
%{_mandir}/man1/mp4box.1*
%{_mandir}/man1/mp4client.1*

%files devel
%defattr(644,root,root,755)
%{_includedir}/gpac

%if %{with wx}
%files gui
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/Osmo4
%endif

%files -n browser-plugin-%{name}
%defattr(644,root,root,755)
%attr(755,root,root) %{_browserpluginsdir}/nposmozilla.so
%{_browserpluginsdir}/nposmozilla.xpt

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: gpac.spec,v $
Revision 1.42  2011/09/28 13:59:19  lisu
- rel 8

Revision 1.41  2011/09/28 13:59:04  lisu
- BR: wxGTK2-unicode-devel when wx bcond is enebaled

Revision 1.40  2011/09/28 13:44:22  lisu
- rel 7

Revision 1.39  2011/09/28 13:33:21  lisu
- disable gui subpackage when building without wx support

Revision 1.38  2011/07/24 15:07:56  arekm
- rel 6; avoid -L/usr/lib

Revision 1.37  2011/07/24 14:38:30  arekm
- release 5

Revision 1.36  2011/06/28 16:50:54  arekm
- release 4

Revision 1.35  2011/06/28 16:30:38  arekm
- rel 3; ffmpeg 0.6 is enough (builds even with 0.8 patch)

Revision 1.34  2011/06/27 19:34:21  qboosh
- added ffmped-0.8 patch
- ghost soname symlink
- package headers as -devel
- release 2

Revision 1.33  2011/05/29 19:55:01  qboosh
- added flags patch (fixes build with current toolchain)
- updated xulrunner patch (mozilla-config.h needed by 2.0)
- updated xmlrpc-c BR

Revision 1.32  2011/04/01 18:39:47  qboosh
- added install-is-not-clean patch, pass BUILD_INSTALL - now nothing gets recompiled on make install
- release 1

Revision 1.31  2011/03/30 18:13:05  qboosh
- added ffmpeg patch, build with system ffmpeg (0.6.2 build-tested)

Revision 1.30  2011/03/28 17:39:49  qboosh
- dropped outdated wxWidgets patch, use sed call to set wx-config path;
  enabled by default, packaged in -gui
- updated amr: use floating-point implementation in system amrnb/amrwb libraries;
  added amr patch

Revision 1.29  2011/03/20 13:40:46  qboosh
- up to 0.4.5
- updated install patch
- removed obsolete amd64,libdir patches
- added libpng,pic,xulrunner patches

Revision 1.28  2010/05/16 14:13:56  sparky
- BR: unzip

Revision 1.27  2007/02/13 07:16:47  glen
- tabs in preamble

Revision 1.26  2007/02/12 00:48:53  baggins
- converted to UTF-8

Revision 1.25  2007/01/10 17:42:14  glen
- browser plugins v2; rel 4

Revision 1.24  2006/12/09 11:39:20  glen
- make -j1

Revision 1.23  2006/10/30 18:05:14  shadzik
- support mozilla-firefox-bin; rel++

Revision 1.22  2006/06/12 18:07:43  hawk
- release 2

Revision 1.21  2006/06/12 18:00:29  hawk
- added libdir fix for amd64

Revision 1.20  2006/06/12 17:16:24  hawk
- lets try to fix amd64

Revision 1.19  2006/04/20 21:48:06  mguevara
- repairs with amr bcond return

Revision 1.18  2006/03/19 15:47:09  glen
- drop trigger on mozilla-plugin-gpac (package never existed)
- BR for browser-plugins macros
- adapterized

Revision 1.17  2006/03/19 13:21:51  qboosh
- it includes outdated gecko-sdk, need to switch to system one

Revision 1.16  2006/03/19 12:52:33  qboosh
- use SOURCE1 macro

Revision 1.15  2006/03/19 12:48:00  qboosh
- tabs, 644 for .xpt

Revision 1.14  2006/03/19 12:43:43  maciek2w
- updated to 0.4.0
- changed licence to LGPL
- added subpackage with browser plugin

Revision 1.13  2005/10/31 11:01:55  arekm
- rel 3

Revision 1.12  2005/04/28 19:16:31  qboosh
- less error-prone files

Revision 1.11  2005/04/27 12:26:12  speedy
- release 2

Revision 1.10  2005/04/27 11:09:59  speedy
- build with -fPIC

Revision 1.9  2005/04/27 10:36:57  speedy
- -fPIC (amd64)

Revision 1.8  2005/04/26 21:46:30  speedy
- release 1

Revision 1.7  2005/04/12 21:22:08  qboosh
- removed COPYING from doc (just GPL)

Revision 1.6  2005/04/09 20:05:27  speedy
- fix %%install
- bcond: wx (build with wxWidgets application, experimental)
- release 0.2

Revision 1.5  2005/04/07 21:36:35  speedy
- up to 0.2.4

Revision 1.4  2005/03/23 17:18:07  glen
- dropped SourceX-size

Revision 1.3  2004/10/26 19:19:14  qboosh
- pl desc, cleanups/unifications

Revision 1.2  2004/10/26 06:44:02  ankry
- Summary cosmetics, formattong

Revision 1.1  2004/10/25 22:48:37  mguevara
- GPAC - MPEG-4 tools, spec based on the original Sverker Abrahamsson
  <sverker@abrahamsson.com> spec for RedHat/Fedora
